#-------------------------------------------------------------------------------
# Name:        macPass Beta 1.2
# Purpose:     Change the world
# Author:      Snailface
# Created:     08/24/2013
# Copyright:   (c) Snailface 2013
# License:     See 'License.txt' in the root of this distribution for details.
#------HEADER-------------------------------------------------------------------
import os,sys
import threading
from threading import Timer
import subprocess
import random
import select
import time
from Tkinter import *

macs=[]
options=['']*10
macsize=0
macounter=0
output=''
delay=0
delayInit=0
i=0
halt=0
begin=1
killit=0
modernos=0

#------FUNCTION_DEFS------------------------------------------------------------
def config():
    global options,modernos
    options[0]="Wi-Fi"
    if os.path.isfile('config.txt') == True:
        f=open('config.txt','r')
        options=f.readlines()
        options[0]=options[0].rstrip()
        f.close()
    root.title("macPass Beta 1.2  [adapter="+options[0]+"]")
    if sys.getwindowsversion()[0] >= 6:
        modernos=1

def createmacs():
    if os.path.isfile('macs.txt') == False:
        macends=["46", "40", "41", "42", "43", "44", "45", "4F", "47", "48", "49", "4A", "4B", "4C", "4D", "4E", "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "0A", "0B", "0C", "0D", "0E", "0F", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "1A", "1B", "1C", "1D", "1E", "1F", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "2A", "2B", "2C", "2D", "2E", "2F", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "3A", "3B", "3C", "3D", "3E", "3F", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "5A", "5B", "5C", "5D", "5E", "5F", "60", "61", "62", "63", "64", "66", "65", "67", "68", "69", "6A", "6B", "6C", "6D", "6E", "6F", "70", "71", "72", "73", "74", "75", "76", "77", "78", "79", "7A", "7B", "7C", "7D", "7E", "7F", "80", "81", "82", "83", "84", "85", "86", "87", "88", "89", "8A", "8B", "8C", "8D", "8E", "8F", "90", "91", "92", "93", "94", "95", "96", "97", "98", "99", "9A", "9B", "9C", "9D", "9E", "9F"]
        random.shuffle(macends)

        f=open('macs.txt','w')

        for i in macends:
            f.write("4E53504F4F"+i+'\n')
        f.close()
    if os.path.isfile('macsave.txt') == False:
        f=open('macsave.txt','w')
        f.close()

def readmacs():
    global macs,macsize
    f=open('macs.txt','r')
    macs=f.readlines()
    macs=[s.replace(':', '') for s in macs]
    macs=[s.replace(' ', '') for s in macs]
    f.close()
    macsize=len(macs)

def start():
    global delay,delayInit,halt,macounter,begin
    if halt==0 and begin==0:
        return
    if over.get()!='':
        macounter=int(over.get())
        over.delete(0,END)
    begin=0
    halt=0
    delay=int(button5.get())
    if delay<30:
        delay=30
        button5.delete(0,END)
        button5.insert(0,'30')
    delayInit=int(button5.get())
    swapmac()

def save():
    global macs,macounter,halt,button5
    f=open('macsave.txt','w')
    f.write(str(macounter)+'\n')
    f.write(button5.get()+'\n')
    for i in macs:
        if len(i) == 13:
            f.write('%s' % i)
        else:
            f.write('%s\n' % i)
    f.close()
    halt=1

def load():
    global macs,macsize,macounter,button5
    f=open('macsave.txt','r')
    macs=f.readlines()
    macs=[s.replace(':', '') for s in macs]
    macs=[s.replace(' ', '') for s in macs]

    macounter=int(macs[0])
    macs.pop(0)

    delayInit=int(macs[0])
    macs.pop(0)

    button5.delete(0,END)
    button5.insert(0,str(delayInit))
    over.delete(0,END)

    f.close()
    macsize=len(macs)
    display.delete(1.0,END)
    display.insert(1.0,"Saved MACS loaded. Press Start. ")

def swapmac():
    global macounter,macs,macsize,delay,output,delayInit,killit,options,modernos
    if killit==1:
        return

    if delay==delayInit:
        display.delete(1.0,END)
        p = subprocess.Popen('macshift -i "'+ options[0] +'" ' + macs[macounter], shell=True, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
        output = p.stdout.read()
        display.insert(1.0,output)
    if modernos==1 and delayInit-delay == 10:
        p = subprocess.Popen('netsh wlan start hostednetwork', shell=True, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
        output = p.stdout.read()
        display.delete(1.0,END)
        display.insert(1.0,output)
    else:
        display.delete(1.0,END)
        display.insert(1.0,"Seconds until next change: "+ str(delay))
        display.insert(1.0,macs[macounter]+'\n')
        display.insert(1.0,"Current MAC: "+ str(macounter) +'/'+ str(macsize-1)+'\n')

    delay-=1
    if delay==-1:
        delay=delayInit
        macounter+=1

    if halt==1:
        #display.delete(1.0,END)
        display.insert(1.0,"Saved and Paused.\n")
        return
    elif halt==2:
        #display.delete(1.0,END)
        start()
        return
    elif macounter <= macsize-1:
        t = Timer(1, swapmac)
        t.start()
    else:
        macounter=0
        t = Timer(1, swapmac)
        t.start()

def next():
    global halt,macounter,macsize
    if macounter == macsize-1:
        macounter=-1
    macounter+=1
    halt=2

def randomize():
    global button3
    global macs
    random.shuffle(macs)
    display.delete(1.0,END)
    display.insert(1.0,"Macs shuffled.\n")

def end():
    global killit
    killit=1
    root.destroy()
    sys.exit(0)

#------GUI----------------------------------------------------------------------
root = Tk()
root.resizable(width=FALSE,height=FALSE)
root.protocol('WM_DELETE_WINDOW', end)
ds='sunken'
ss='raised'
bs='raised'

app=Frame(root).grid()

display=Text (app,width=36,height=4,relief=ds,background="#FFD")

display.grid(row=0,column=0,columnspan=2,sticky="nsew",padx=2,pady=2)
button2=Button(app,text='Start',width=16,height=4,command=start,relief=ss,background="#EEE").grid(row=0,column=2,columnspan=2,padx=2,pady=2)

button3=Button(app,text='Shuffle Macs',width=16,height=2,command=randomize,relief=bs,background="#FFFFFF")
button3.grid(row=1,column=0,sticky="ew",padx=1,pady=1)

button4=Button(app,text='Next Mac',width=16,height=2,command=next,relief=bs,background="#FFFFFF").grid(row=1,column=1,sticky="ew",padx=1,pady=1)

button10=Button(app,text='Save/Pause',width=16,height=2,command=save,relief=bs,background="#FFFFFF").grid(row=2,column=0,sticky="ew",padx=1,pady=1)
button11=Button(app,text='Load',width=16,height=2,command=load,relief=bs,background="#FFFFFF").grid(row=2,column=1,sticky="ew",padx=1,pady=1)

label1= Label  (app,text='[ Delay ]  [ Begin ]',width=16,height=2).grid(row=1,column=2,sticky="s")

over  = Entry  (app,width=6,background="#FFD")
over.grid(row=2,column=2,sticky="e",padx=15)
#over.insert(0,'0')

button5= Entry(app,width=6,background="#FFD")
button5.grid(row=2,column=2,sticky="w",padx=15)
button5.insert(0,'60')

display.insert(1.0,'Welcome to macPass by Snailface.\nPlease enter a delay in seconds and press Start.')
#------MAIN------------------------------------------------------------------
config()
createmacs()
readmacs()
root.mainloop()